<script lang="ts">
import { inject, ref, useTemplateRef } from 'vue';
import { IProvideScrollbar, jScrollbarKey } from './useCustomScrollbar';

export default {
  name: 'JScrollbarTrack',
  props: {
    hideTrack: {
      type: Boolean,
      default: false,
    },
    hideThumb: {
      type: Boolean,
      default: false,
    },
  },
  setup() {
    const trackRef = useTemplateRef<HTMLDivElement>('trackRef');
    const isDraggable = ref(false);

    const scrollbarProps = inject<IProvideScrollbar>(jScrollbarKey);

    if (scrollbarProps === undefined) {
      throw new Error('Not provided JScrollbarTrack props');
    }

    const { thumbScrollPosition, thumbScrollSize, onThumbDown, onThumbMove, scrollTo } =
      scrollbarProps;

    const onMouseMove = (event: MouseEvent) => {
      onThumbMove(event);
    };

    const onDragDown = (event: MouseEvent) => {
      onThumbDown(event);

      isDraggable.value = true;

      document.addEventListener('mousemove', onMouseMove);
      document.addEventListener('mouseup', onDragUp);
    };

    const onDragUp = () => {
      isDraggable.value = false;
      document.removeEventListener('mousemove', onMouseMove);
      document.removeEventListener('mouseup', onDragUp);
    };

    const onTrackClick = (event: MouseEvent) => {
      event.preventDefault();
      event.stopPropagation();

      if (trackRef.value === null) return;

      const trackHeight = trackRef.value.clientHeight;

      const { clientY } = event;
      const target = event.target as HTMLDivElement;

      const rect = target.getBoundingClientRect();
      const trackTop = rect.top;

      const thumbOffset = -(thumbScrollSize.value / 2);
      const clickRatio = (clientY - trackTop + thumbOffset) / trackHeight;

      scrollTo(clickRatio);
    };

    return {
      trackRef,
      onDragDown,
      onDragUp,
      isDraggable,
      thumbScrollPosition,
      thumbScrollSize,
      onTrackClick,
    };
  },
};
</script>

<template>
  <div
    v-if="thumbScrollSize !== 0"
    ref="trackRef"
    class="j-scrollbar-track"
    :class="{ 'j-hide-track': hideTrack, active: isDraggable }"
    @click="onTrackClick"
  >
    <div
      :style="{ height: thumbScrollSize + 'px', transform: `translateY(${thumbScrollPosition}px)` }"
      class="j-scrollbar-thumb"
      :class="{ active: isDraggable, 'j-hide-thumb': hideThumb }"
      @click.stop.prevent
      @mousedown.stop.prevent="onDragDown"
    ></div>
  </div>
</template>

<style scoped lang="scss">
@use './mixins' as scrollbarMixins;

.j-scrollbar-track {
  position: absolute;
  top: 0;
  right: 2px;
  width: 4px;
  height: 100%;

  &::before {
    content: '';
    position: absolute;
    width: 100%;
    height: 100%;
    border-radius: 10px;
    transition: opacity 100ms ease-in-out;
    background-color: rgb(195, 195, 195);

    @include scrollbarMixins.hide-scrollbar;
  }

  &:hover,
  &.active {
    &::before {
      @include scrollbarMixins.active-track;
    }
  }
}

.j-hide-track {
  &::before {
    display: none;
  }
}

.j-hide-thumb {
  @include scrollbarMixins.hide-scrollbar;
}

.j-scrollbar-thumb {
  width: 100%;
  border-radius: 10px;
  cursor: pointer;
  background-color: rgb(195, 195, 195);
  transition: opacity 100ms ease-in-out;

  &:hover,
  &.active {
    background-color: rgba(91, 95, 199, 0.4);

    @include scrollbarMixins.active-thumb;
  }
}
</style>
